# Patch version of cookId function
# Original version is on OFS.Image

import string

VALID_ID_CHARACTERS = string.digits + string.ascii_letters + '-_ .'
INVALID_ID_FIRST_OR_LAST_CHARACTERS = '_ '

def makeValidId(id):
    id = id.strip(INVALID_ID_FIRST_OR_LAST_CHARACTERS)
    validId = ''
    for c in id:
        if c in VALID_ID_CHARACTERS:
            validId += c
    return validId


def cookId(id, title, file):
    if not id and hasattr(file,'filename'):
        filename=file.filename
        title=title or filename
        id=filename[max(filename.rfind('/'),
                        filename.rfind('\\'),
                        filename.rfind(':'),
                        )+1:]
        id = makeValidId(id)
    return id, title 